Name:         kolab-server
Summary:      Kolab Groupware Server
URL:          http://kroupware.org
Group:        System/Servers
License:      GPL
Version:      1.0
Release:      0.16mdk

Source0:      ftp://ftp.kde.org/pub/kde/unstable/server/kolab/kolab-current/kolab-%{version}.tar.gz
Source1:      Makefile
Source2:      rc.kolab
Source3:      httpd.conf.template
Source4:      legacy.conf.template
Source5:      kolab-fixperms.sh
Source6:      main.cf.template
Source7:      cyrus.conf.template
Source8:      kolab_backup
Source9:      slapd.conf.template
Source10:     kolab-schemas.tar.bz2
Patch0:	      kolab-admin.patch.bz2
Patch1:	      kolab-vacation.patch.bz2
Patch2:	      kolab-slapd.patch.bz2
Buildarch: noarch

Prefix:       %{_prefix}
BuildRoot:    %{_tmppath}/%{name}-%{version}-root
PreReq:	      rpm-helper
PreReq:       openldap-servers, postfix, cyrus-imapd, cyrus-sasl, apache2
PreReq:	      cyrus-imapd-utils, proftpd
Requires:     perl-Convert-ASN1, perl-ldap, perl-Cyrus, perl-Net-Netmask
Requires:     perl-Term-ReadKey
Requires:     apache2-mod_ssl, apache2-mod_dav, apache2-mod_ldap
Requires:     apache2-mod_php, php-ldap, php-xml, php-ini
Requires:     libsasl2-plug-plain

%description
Kolab is the KDE Groupware Server that provides full groupware features
to either KDE Kolab clients or Microsoft Outlook[tm] clients running on 
Windows[tm] using the Konsec Konnector http://www.konsec.com. 
In addition it is a robust and flexible general imap mail server with 
LDAP addressbook and nice web gui for administration.

%prep
%setup -q -c
%patch 
%patch1 -p1
%patch2
cp %{SOURCE3} .
cp %{SOURCE4} .
cp %{SOURCE5} .
rm admin/expert -rf
cp %{SOURCE6} .
cp %{SOURCE7} .
cp %{SOURCE8} .
cp %{SOURCE9} .

%build
#MAJOR FIXES:

#We don't use the @domain part in the ldap database, so change the
#nomenclature for "UserName" in php frontend so people are not confused.
perl -pi -e "s|Primary Email Address|UserName|;" admin/user/create_user.php

#Remove master.cf and php.ini from templates
perl -pi -e "s|^.*php.ini.*$||;" kolab
perl -pi -e "s|^.*master.cf.*$||;" kolab
rm -f php.ini.template
rm -f master.cf.template

# Start LDAP as user ldap
perl -pi -e "s|-h |-u ldap -g ldap -h |;" kolab_bootstrap

#Change "greed" of regexp so it works with Apache2 since
#we use an ldap URL instead of a hostname and port and we
#need to change multiple variables on the same line.
perl -pi -e "s|S\+|S+?|g;" kolab

#Chown now uses a column instead of a dot
perl -pi -e 's|root\.root|root:root|g;' kolab

# MANDRAKE PATHS
# Yes, it's very ugly, and please don't macroize this, as this
# will become impossible to debug. 

perl -pi -e 's;\@\@\@kolab_prefix\@\@\@\/bin;/usr/bin;g' \
	*.template kolab* workaround.sh
perl -pi -e 's;\@\@\@kolab_prefix\@\@\@\/sbin;/usr/sbin;g' \
	*.template kolab* workaround.sh
perl -pi -e 's;\@\@\@kolab_prefix\@\@\@\/etc;/etc;g' \
	*.template kolab* workaround.sh

#FIXME! The Apache paths must go in /var/www/html, but anyways
#we'll nuke the template and replace it with our own
perl -pi -e 's;/kolab/var/kolab;/var/kolab;g' httpd.conf.template
perl -pi -e 's;/var/kolab/www;/var/www/html/kolab;g' *.template kola* w*.sh
perl -pi -e 's;/var/apache/log;/var/log/httpd;g' httpd.conf.template
perl -pi -e 's; var/apache/log; /var/log/httpd;g' httpd.conf.template
perl -pi -e 's; var/apache/run/apache.pid; /var/run/httpd.pid;g' httpd.conf.template
perl -pi -e 's;etc/apache/mime.types;/etc/httpd/conf/apache-mime.types;g' \
	httpd.conf.template
perl -pi -e 's;etc/apache/magic;/etc/httpd/conf/magic;g' \
	httpd.conf.template

perl -pi -e 's;/var/kolab/lmtp;/var/spool/postfix/extern/cyrus/lmtp;g' *.template

perl -pi -e 's;/var/openldap/openldap-data;/var/lib/ldap;g' slapd.conf.template
perl -pi -e 's;/var/openldap/replog;/var/run/ldap/openldap-slurp/replog;g' slapd.conf.template
perl -pi -e 's;/var/openldap;/var/run/ldap;g' slapd.conf.template
perl -pi -e 's;/var/imapd/sieve;/var/lib/imap/sieve;g' imapd.conf.template
perl -pi -e 's;/var/imapd/spool;/var/spool/imap;g' imapd.conf.template
perl -pi -e 's;/var/imapd;/var/lib/imap;g' imapd.conf.template
perl -pi -e 's;/libexec/postfix;/usr/lib/postfix;g' main.cf.template
perl -pi -e 's;/var/postfix;/var/spool/postfix;g' main.cf.template
perl -pi -e 's;/var/proftpd/score;/var/run/proftpd/score;g' pro*
perl -pi -e 's;/var/proftpd/proftpd.log;/var/log/proftpd/proftpd.log;g' \
	proftpd* kolab

perl -pi -e 's;/var/kolab/kolab.pid;/var/run/kolab.pid;g' kolab
perl -pi -e 's;/etc/imapd/cyrus.conf;/etc/cyrus.conf;g' kolab
perl -pi -e 's;/etc/imapd/imapd.conf;/etc/imapd.conf;g' kolab
perl -pi -e 's;/etc/proftpd/proftpd.conf;/etc/proftpd.conf;g' kolab
perl -pi -e 's;/var/proftpd/proftpd.pid;/var/run/proftpd.pid;g' kolab
perl -pi -e 's;/etc/imapd/imapd.group;/etc/imapd.group;g' kolab
perl -pi -e 's;/etc/sasl/saslauthd.conf;/etc/saslauthd.conf;g' kolab

#FIXME! We have to get rid of the ugly Apache and PHP templates, 
#since we'll use our standard ADVX mechanisms.
perl -pi -e 's;/etc/apache/apache.conf;/etc/httpd/conf.d/99_kolab.conf;g' kolab
perl -pi -e 's;/etc/apache/legacy.conf;/etc/httpd/conf/k-legacy.conf;g' kolab

perl -pi -e 's;/etc/rc.d/rc.imapd;/etc/init.d/cyrus-imapd;g' kolab
perl -pi -e 's;/etc/rc.d/rc.proftpd;/etc/init.d/proftpd;g' kolab
perl -pi -e 's;/etc/rc.d/rc.openldap;/etc/init.d/ldap;g' kolab
perl -pi -e 's;/etc/rc.d/rc.sasl;/etc/init.d/saslauthd;g' kolab
perl -pi -e 's;kolab_prefix/sbin/;kolab_prefix/usr/sbin/;g' kolab

perl -pi -e 's;/libexec/slapd;/usr/sbin/slapd;g' kolab_bootstrap
perl -pi -e 's;/kolab/etc/kolab/;/etc/kolab/;g' kolab_bootstrap
perl -pi -e 's;/kolab/etc/rc.d/rc.kolab;service kolab-server;g' kolab_bootstrap
perl -pi -e 's;/etc/kolab/kolab ;/usr/sbin/kolab ;g' kolab_boostrap

perl -pi -e 's;/etc/sasl/apps/smtpd.conf;/usr/lib/sasl2/smtpd.conf;g' kolab_bootstrap

perl -pi -e 's;/kolab/bin/cyradm;/usr/bin/cyradm;g' workaround.sh

perl -pi -e 's;\@\@\@kolab_prefix\@\@\@;;g' *.template kola* w*.sh

#FIXME! More Apache nonsense ;-)
perl -pi -e 's;\@l_nusr\@;apache;g' httpd.conf.template
perl -pi -e 's;\@l_ngrp\@;apache;g' httpd.conf.template

perl -pi -e 's;\@\@\@l_musr\@\@\@;postfix;g' main.cf.template
perl -pi -e 's;\@\@\@l_rgrp\@\@\@;postdrop;g' main.cf.template
perl -pi -e 's;\@\@\@l_nusr\@\@\@;nobody;g' main.cf.template 

perl -pi -e 's|\@\@\@l_nusr\@\@\@|nobody|g' proftpd.conf.template
perl -pi -e 's|\@\@\@l_nuid\@\@\@|65534|g' proftpd.conf.template
perl -pi -e 's|\@\@\@l_ngrp\@\@\@|nogroup|g' proftpd.conf.template
perl -pi -e 's|\@\@\@l_ngid\@\@\@|65534|g' proftpd.conf.template 

# Nuke the prefix as we don't need it and it makes the sources
# more readable
perl -pi -e 's|\$kolab_prefix/|/|g;' kolab kolab_bootstrap
perl -pi -e 's|\$kolab_prefix\.||g;' kolab kolab_bootstrap

#Modify to use initscripts correctly
perl -pi -e 's|(system\("/etc/init.d/proftpd stop"\))|\1 if \(-e "/var/run/proftpd.pid"\)|' kolab
perl -pi -e 's|stop; sleep 1; /usr/sbin/saslauthd -a ldap -n 5|restart|;' kolab

#Have apache restart even if config file has different name
perl -pi -e 's|/apache/|/httpd/|;' kolab
perl -pi -e 's|/usr/sbin/apachectl reload|/etc/init.d/httpd restart|;' kolab

#Fix path of kolab in boostrap
perl -pi -e 's|/etc/kolab/kolab |/usr/sbin/kolab |g;' kolab_bootstrap

#Replace kolab_bootstrap by kolab_backup
mv kolab_bootstrap kolab_bootstrap.real
mv kolab_backup kolab_bootstrap

perl -pi -e "s|chgrp kolab|#chgrp kolab|g;" kolab_sslcert.sh

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p -m 755 $RPM_BUILD_ROOT/%{_sysconfdir}/kolab
mkdir -p -m 755 $RPM_BUILD_ROOT/%{_initrddir}
mkdir -p -m 755 $RPM_BUILD_ROOT/%{_sbindir}
mkdir -p -m 755 $RPM_BUILD_ROOT/var/spool/kolab
mkdir -p -m 755 $RPM_BUILD_ROOT/var/www/html/kolab/freebusy
mkdir -p -m 755 $RPM_BUILD_ROOT/var/www/html/kolab/locks

install -c -m 755 %{SOURCE2} $RPM_BUILD_ROOT/%{_initrddir}/kolab-server
install -c -m 644 *.template $RPM_BUILD_ROOT/%{_sysconfdir}/kolab/
install -c -m 755 kolab $RPM_BUILD_ROOT/%{_sbindir}
install -c -m 644 kolab.conf $RPM_BUILD_ROOT/%{_sysconfdir}/kolab/
install -c -m 644 *.schema $RPM_BUILD_ROOT/%{_sysconfdir}/kolab/
install -c -m 644 %{SOURCE10} $RPM_BUILD_ROOT/%{_sysconfdir}/kolab/
install -c -m 755 kolab_bootstrap $RPM_BUILD_ROOT/%{_sbindir}
install -c -m 755 kolab_bootstrap.real $RPM_BUILD_ROOT/%{_sbindir}
install -c -m 755 workaround.sh $RPM_BUILD_ROOT/%{_sysconfdir}/kolab/ 	
install -c -m 755 kolab-fixperms.sh $RPM_BUILD_ROOT/%{_sysconfdir}/kolab/ 	
cp -r admin/ $RPM_BUILD_ROOT/var/www/html/kolab/

# gets overwritten later
install -c -m 755 kolab_sslcert.sh $RPM_BUILD_ROOT/%{_sysconfdir}/kolab/

cat << EOF > README
This is the first draft of the kolab-server. The web interface should work,
namely adding/removing/modifying users, and the LDAP authentication should
work with Apache, PHP and cyrus-imap. There's still some work to do,
specially testing postfix and proftpd.

To test it, do the following:
1) /usr/sbin/kolab_bootstrap -b (note the manager password)
2) service kolab-server start
3) point your browser to https://localhost/kolab/admin and login as
   user "manager", with the password chosen in step 1.
4) create/modify/delete users
5) close all your browser windows, then return back to the web
administration site, but log in as a regular user you just created, to test
the forwarding and vacation functions, changing password, etc.
6) point your mail client smtp and imap servers to localhost, and try to
send yourself some mail, and read it.

To test the calendaring functions, you'll need the kroupware client, or
Microsoft Outlook with the Binary connector (proprietary).
EOF

%post
%{_sysconfdir}/kolab/kolab-fixperms.sh
%_post_service kolab-server
    echo "For a fresh installation please initialize Kolab and run '%{_sbindir}/kolab_bootstrap -b'."
    echo "If you upgraded from a previous version simply refresh Kolab and run '%{_sbindir}/kolab -o -v'."
    echo "In every case execute 'service kolab-server restart'"

%preun
%_preun_service kolab-server

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README
%dir %config %{_sysconfdir}/kolab
%config(noreplace) %{_sysconfdir}/kolab/*
%config(noreplace) %{_initrddir}/kolab-server
%{_sbindir}/*
%dir /var/www/html/kolab
/var/www/html/kolab/*
%dir /var/spool/kolab

%changelog
* Thu Mar 25 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.16mdk
- revert to original, ugly, incompatible kolab schema
- include a tar.bz2 of tentative schemas so other people can hack them.

* Thu Mar 25 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.15mdk
- really fix schema =(

* Thu Mar 25 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.14mdk
- kolab needs a slightly modified version of core.schema, etc. Put those
  modified schemas in /etc/kolab so people can still use their LDAP server
  for other things while satifsying kolab at the same time

* Thu Mar 25 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.13mdk
- change /var/run/openldap-slurp for /var/lib/ldap
- get rid of TLS_CACERT in /etc/openldap/ldap.conf
- use schemas from openldap
- wrap apache directives in <Ifmodule> directives so we don't break
  httpd2 -t

* Wed Mar 23 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.12mdk
- fix user manager ACL so we can use phpLDAPAdmin, LDIF import, or other
  user import tools.

* Sun Mar 21 2004 Jean-Michel dault <jmdault@mandrakesoft.com> 1.0-0.11mdk
- fix vacation (was crashing php when no @domain part in email)
- remove german message and shorten the english one to a generic two-line
  message.
- fix bug 8988 (error in readme) and 8989 (chgrp kolab)

* Fri Feb 13 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.10mdk
- fixes for new Postfix
- change "Primary Email Address" for "UserName" in php frontend since we
  don't use the "@domain" part in the ldap database, and it can confuse
  people.

* Thu Jan 29 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.9mdk
- replace /etc/kolab/kolab by /usr/sbin/kolab

* Thu Jan 29 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.8mdk
- apache needs a restart, not a reload

* Thu Jan 29 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.7mdk
- reload apache correctly

* Thu Jan 29 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.6mdk
- fix lmtpd socket permissions

* Thu Jan 29 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.5mdk
- source /etc/init.d/functions and replace echo by gprintf
- misc fixes to kolab_backup and rc.kolab

* Thu Jan 29 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.4mdk
- really use initscripts
- check config at most actions instead of just start. However, don't
  do it for stop, since it's used to make sure all services are stopped,
  before bootstrap.
- create a script to backup the existing config before bootstrap
- fix ldap to start as user ldap, not user root
- modify templates for postfix and cyrus according to Luca Berra's
  suggestions.

* Wed Jan 14 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.3mdk
- The lmtp in /var/spool/kolab is a socket, not a directory!
- fix rc script to use /etc/init.d scripts and not reinvent the wheel in
  most cases (still sasl and proftpd to fix)

* Tue Jan 06 2004 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.2mdk
- fix requires (thanks Camille!)
- fix post_service and preun_service
- update README


* Mon Dec 22 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.0-0.1mdk
- initial Mandrake release, most of the work taken from Buchan Milne's spec
  file.
- Major testing and debugging went into this release, specially on the
  web administration part, but there's still a lot of work to do to make all
  the server components work well together.
- Read the README file in the documentation for more info.
